> For the complete documentation index, see [llms.txt](https://docs.flatredball.com/flatredball/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.flatredball.com/flatredball/api/flatredball/graphics/text/coloroperation.md).

# ColorOperation

### Introduction

The Text class implements the [IColorable](https://github.com/flatredball/FlatRedBallDocs/tree/main/frb/docs/index.php) interface. This gives the Text object lots of flexibility in controlling how it will appear.

For information that is general to all [IColorables](https://github.com/flatredball/FlatRedBallDocs/tree/main/frb/docs/index.php), see the [IColorable page.](https://github.com/flatredball/FlatRedBallDocs/tree/main/frb/docs/index.php)

### Default Behavior

By default the Text class has the following [IColorable](https://github.com/flatredball/FlatRedBallDocs/tree/main/frb/docs/index.php) properties:

| Property                                                                                      | Value              |
| --------------------------------------------------------------------------------------------- | ------------------ |
| [ColorOperation](https://github.com/flatredball/FlatRedBallDocs/tree/main/frb/docs/index.php) | ColorTextureAlpha  |
| Red                                                                                           | 1 (255 in FRB MDX) |
| Green                                                                                         | 1 (255 in FRB MDX) |
| Blue                                                                                          | 1 (255 in FRB MDX) |

Notice that the [ColorOperation](https://github.com/flatredball/FlatRedBallDocs/tree/main/frb/docs/index.php) is "ColorTextureAlpha". This means that the Texture will control the transparency (of course, also considering the Text's Alpha property), but the color is controlled purely by the Red, Green, and Blue properties.

Therefore, by default, the Text object will completely ignore color information from its source Texture and use **only** the three color components that are set.

This can be easily changed, of course. If you want to set the color of your text from its source texture (as might be the case when doing outlined text), consider changing the [ColorOperation](https://github.com/flatredball/FlatRedBallDocs/tree/main/frb/docs/index.php) to Texture or Modulate depending on the effect you are interested in achieving.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.flatredball.com/flatredball/api/flatredball/graphics/text/coloroperation.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
